/*
SIGNATURE API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package signaturesapi

import (
	"encoding/json"
)

// checks if the CreateInsignConfigRequestPaid type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CreateInsignConfigRequestPaid{}

// CreateInsignConfigRequestPaid struct for CreateInsignConfigRequestPaid
type CreateInsignConfigRequestPaid struct {
	ApiUrl string `json:"api_url"`
	WebUrl string `json:"web_url"`
	Username string `json:"username"`
	Password string `json:"password"`
}

// NewCreateInsignConfigRequestPaid instantiates a new CreateInsignConfigRequestPaid object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreateInsignConfigRequestPaid(apiUrl string, webUrl string, username string, password string) *CreateInsignConfigRequestPaid {
	this := CreateInsignConfigRequestPaid{}
	this.ApiUrl = apiUrl
	this.WebUrl = webUrl
	this.Username = username
	this.Password = password
	return &this
}

// NewCreateInsignConfigRequestPaidWithDefaults instantiates a new CreateInsignConfigRequestPaid object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreateInsignConfigRequestPaidWithDefaults() *CreateInsignConfigRequestPaid {
	this := CreateInsignConfigRequestPaid{}
	return &this
}

// GetApiUrl returns the ApiUrl field value
func (o *CreateInsignConfigRequestPaid) GetApiUrl() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ApiUrl
}

// GetApiUrlOk returns a tuple with the ApiUrl field value
// and a boolean to check if the value has been set.
func (o *CreateInsignConfigRequestPaid) GetApiUrlOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ApiUrl, true
}

// SetApiUrl sets field value
func (o *CreateInsignConfigRequestPaid) SetApiUrl(v string) {
	o.ApiUrl = v
}

// GetWebUrl returns the WebUrl field value
func (o *CreateInsignConfigRequestPaid) GetWebUrl() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.WebUrl
}

// GetWebUrlOk returns a tuple with the WebUrl field value
// and a boolean to check if the value has been set.
func (o *CreateInsignConfigRequestPaid) GetWebUrlOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.WebUrl, true
}

// SetWebUrl sets field value
func (o *CreateInsignConfigRequestPaid) SetWebUrl(v string) {
	o.WebUrl = v
}

// GetUsername returns the Username field value
func (o *CreateInsignConfigRequestPaid) GetUsername() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Username
}

// GetUsernameOk returns a tuple with the Username field value
// and a boolean to check if the value has been set.
func (o *CreateInsignConfigRequestPaid) GetUsernameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Username, true
}

// SetUsername sets field value
func (o *CreateInsignConfigRequestPaid) SetUsername(v string) {
	o.Username = v
}

// GetPassword returns the Password field value
func (o *CreateInsignConfigRequestPaid) GetPassword() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Password
}

// GetPasswordOk returns a tuple with the Password field value
// and a boolean to check if the value has been set.
func (o *CreateInsignConfigRequestPaid) GetPasswordOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Password, true
}

// SetPassword sets field value
func (o *CreateInsignConfigRequestPaid) SetPassword(v string) {
	o.Password = v
}

func (o CreateInsignConfigRequestPaid) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CreateInsignConfigRequestPaid) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["api_url"] = o.ApiUrl
	toSerialize["web_url"] = o.WebUrl
	toSerialize["username"] = o.Username
	toSerialize["password"] = o.Password
	return toSerialize, nil
}

type NullableCreateInsignConfigRequestPaid struct {
	value *CreateInsignConfigRequestPaid
	isSet bool
}

func (v NullableCreateInsignConfigRequestPaid) Get() *CreateInsignConfigRequestPaid {
	return v.value
}

func (v *NullableCreateInsignConfigRequestPaid) Set(val *CreateInsignConfigRequestPaid) {
	v.value = val
	v.isSet = true
}

func (v NullableCreateInsignConfigRequestPaid) IsSet() bool {
	return v.isSet
}

func (v *NullableCreateInsignConfigRequestPaid) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreateInsignConfigRequestPaid(val *CreateInsignConfigRequestPaid) *NullableCreateInsignConfigRequestPaid {
	return &NullableCreateInsignConfigRequestPaid{value: val, isSet: true}
}

func (v NullableCreateInsignConfigRequestPaid) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreateInsignConfigRequestPaid) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


